"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _atpRest = require("atp-rest");

var _atpRestUac = require("atp-rest-uac");

var _file = require("../model/file");

var _file2 = _interopRequireDefault(_file);

var _randomstring = require("randomstring");

var _randomstring2 = _interopRequireDefault(_randomstring);

var _util = require("../util");

var _atpPointfree = require("atp-pointfree");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var model = _file2.default;
var permissions = (0, _atpRestUac.createCrudPermissions)('media', 'file');
var idField = 'fileId';

var uploadFile = function uploadFile(file) {
    file.s3Prefix = _randomstring2.default.generate({ length: 8, readable: true });
    var fileNameFull = file.s3Prefix + " - " + file.fileName + "." + file.fileExtension;
    return (0, _util.s3)().upload(fileNameFull, file.data).then(function () {
        delete file.data;
        return file;
    });
};

var deleteS3Files = function deleteS3Files(id) {
    return new model().getById(id).then((0, _atpPointfree._)((0, _util.s3)().listObjects, function (media) {
        return "" + (media.s3Prefix ? media.s3Prefix + " - " : "") + media.fileName;
    })).then((0, _util.s3)().deleteObjects);
};

exports.default = _atpRest.basicController.entity.crud({
    model: model, permissions: permissions, idField: idField,
    validateCreate: function validateCreate(v) {
        return v;
    },
    preInsert: uploadFile,
    preUpdate: function preUpdate(file, id) {
        return file.data ? uploadFile(file).then(function (file) {
            return deleteS3Files(id).then(function () {
                return file;
            });
        }) : Promise.resolve(file);
    },
    preDelete: function preDelete(req) {
        return deleteS3Files(req.params[idField]);
    }
});