'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.s3 = undefined;

var _atpConfig = require('atp-config');

var _atpConfig2 = _interopRequireDefault(_atpConfig);

var _awsSdk = require('aws-sdk');

var _awsSdk2 = _interopRequireDefault(_awsSdk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var s3 = exports.s3 = function s3() {
    var awsConfig = _atpConfig2.default.get('media.aws');
    _awsSdk2.default.config.update({ region: awsConfig.region });
    var _s3 = new _awsSdk2.default.S3({ params: { Bucket: awsConfig.bucket } });

    return {
        upload: function upload(key, file) {
            return new Promise(function (resolve, reject) {
                _s3.upload({
                    Key: key,
                    Body: Buffer.from(file, 'base64'),
                    ACL: 'public-read'
                }, function (err, data) {
                    if (err) {
                        reject(err.message);
                    } else {
                        resolve();
                    }
                });
            });
        },
        listObjects: function listObjects(Prefix) {
            return new Promise(function (resolve, reject) {
                _s3.listObjects({
                    Prefix: Prefix
                }, function (err, data) {
                    if (err) {
                        reject(err.message);
                    } else {
                        resolve(data.Contents);
                    }
                });
            });
        },
        deleteObjects: function deleteObjects(objects) {
            return new Promise(function (resolve, reject) {
                if (objects.length === 0) {
                    resolve();
                    return;
                }
                _s3.deleteObjects({
                    Delete: { Objects: objects.map(function (_ref) {
                            var Key = _ref.Key;
                            return { Key: Key };
                        }) }
                }, function (err, data) {
                    if (err) {
                        reject(err.message);
                    } else {
                        resolve();
                    }
                });
            });
        }
    };
};